<template>
   <div class="payform">

       <div class="payform__pay-card">
           <ui-row>
               <!-- данные карты -->
               <ui-col class=" payform__half payform__half-left" :xs="24" :md="12">
                   <ui-row>
                       <ui-col :xs="24">
                           <div class="payform__card-list" v-if="tokenAccount.length > 1">
                               <ui-radio-list v-model.number="account"
                                              :items="tokenAccount">
                               </ui-radio-list>
                           </div>
                       </ui-col>
                   </ui-row>
                   <transition name="fade">
                       <div v-if="!account" class="payform__pay-card-new">
                           <div class="payform__pay-card-new__wrapper">
                               <ui-row>
                                   <ui-col :xs="24">
                                       <ui-input
                                           label="Номер карты"
                                           :mask="cardMask"
                                           placeholder="#### #### #### ####"
                                           type="tel"
                                           :autocomplite="false"
                                           v-model="card.number"
                                           :error="$v.card.number.$invalid && !$v.card.number.$pending && card.number ? 'Проверьте номер карты' : ''"
                                           :suffix="!!(paySystemLogo && card.number)">
                                           <template v-if="paySystemLogo && card.number" slot="suffix">
                                               <img :src="paySystemLogo" v-if="paySystemLogo" alt="Платежная система">
                                           </template>
                                       </ui-input>

                                   </ui-col>
                               </ui-row>
                               <ui-row>
                                   <ui-col :xs="24" :md="12">
                                       <ui-input label="Срок действия"
                                                 type="tel"
                                                 :mask="'##/##'"
                                                 v-model="card.date"
                                                 placeholder="ММ/ГГ"
                                                 :autocomplite="false"

                                                 :error="$v.card.date.$invalid && !$v.card.date.$pending && card.date ? 'Ошибка даты' : ''"
                                       ></ui-input>
                                   </ui-col>
                                   <ui-col :xs="24" :md="12">
                                       <ui-input
                                               label="CVV/CVC"
                                               v-model="card.cvv"
                                               type="cvv"
                                               :autocomplite="false"

                                               :error="$v.card.cvv.$invalid && !$v.card.cvv.$pending && card.cvv ? 'Код содержит 3 цифры' : ''"
                                               mask="###"></ui-input>
                                   </ui-col>
                               </ui-row>
                               <ui-row>
                                   <ui-col :xs="24">
                                       <ui-input
                                               label="Имя держателя"
                                               v-model="card.holder"
                                               :autocomplite="false"

                                               @input="ru2en"
                                       ></ui-input>
                                   </ui-col>
                               </ui-row>
                           </div>
                       </div>
                   </transition>
               </ui-col>

               <!-- информация о платеже -->
               <ui-col :xs="24" :md="12" class="payform__details-wrapper payform__half payform__half-right">
                  <div class="payform__details-list">
                      <div v-for="(item, index) in paymentDetails" :key="index" class="payform__details-list-item">
                          <div>{{item.title}}</div>
                          <div>{{item.sum|currency}} ₽</div>
                      </div>
                      <div class="payform__details-list-item summary">
                          <div class="title">Сумма к оплате</div>
                          <div class="sum">{{totalAmount|currency}} ₽</div>
                      </div>
                  </div>

                   <div>
                       <ui-button block
                                  @click="initPay"
                                  color="red"
                                  :disabled="loading"
                                  center>
                           Оплатить
                       </ui-button>
                       <ui-button block
                                  bold
                                  link
                                  center
                                  @click="$emit('cancel')">
                           Отменить
                       </ui-button>
                   </div>
               </ui-col>
           </ui-row>
       </div>
       <modal-tds @result-success="$emit('tds.ok');" @result-error="$emit('tds.error')"></modal-tds>
   </div>
</template>

<script>
    import creditCardType from 'credit-card-type';
    import {validationMixin} from 'vuelidate';
    import {cardCheckSum, cardCheckDate, cardCheckCvv} from '@/common/validators/payment/card';
    import {mapGetters} from 'vuex';
    import CardPaymentProcess from '@/classes/CardPaymentProcess.class';
    import ModalTds from '../components/TDS/tds';
    import {convert} from '@/common/utils/ru-en'

    export default {
        name: 'component-payform-method-card',
        mixins: [validationMixin],
        components: {
            ModalTds
        },
        data () {
            return {
                account: 0,
                card: {
                    number: '',
                    date: '',
                    cvv: '',
                    holder: '',
                },
                paySystemLogo: '',
                cardMask: '#### #### #### ####',
                loading: false,
            }
        },

        computed: {
            totalAmount () {
                return this.$store.getters.additionalServicesPrice + this.$pay.paymentAmount;
            },
            paymentDetails () {
                const data = [{
                    title: 'Вносимый платеж',
                    sum: this.$pay.paymentAmount
                }];

                this.$pay.additionalServices.filter((/*iAdditionalService*/ service) => {
                    return service.selected && [3].includes(service.location_int);
                }).forEach((/*iAdditionalService*/ service) => {
                    data.push({
                        title: service.title,
                        sum: service.price
                    })
                });

                return data;

            },
            tokenAccount () {
                return this.$accounts.filter(a => a.has_token).map((a) => {
                    let symbols = a.description.split('-');
                    let img = creditCardType(symbols[0]);

                    const paySystemImage = (img[0]) ?
                        `/lk/static/img/my-accounts/${img[0].type}.png` :
                        '';

                    return {
                        id: a.id,
                        number: a.description,
                        image: paySystemImage
                    }
                }).concat([{
                    id: 0,
                    number: 'Новая карта',
                    image: `/lk/static/img/accounts/card-add.png`
                }])
            },
            ...mapGetters(['$POS'])
        },

        validations: {
            card: {
                number: {
                    cardCheckSum
                },
                date: {
                    cardCheckDate
                },
                cvv: {
                    cardCheckCvv
                }
            }
        },

        watch: {
            'card.number' (card) {
                let symbols = card.split(' ');
                this.series = symbols;
                this.updateCardMask(creditCardType(symbols[0]));
                let img = creditCardType(symbols[0]);
                this.paySystemLogo = (card && img[0]) ?
                    `/lk/static/img/my-accounts/${img[0].type}.png` :
                    '';
            },
        },

        methods: {

            ru2en (v) {
                this.card.holder =  convert().toEn(v).toUpperCase();
            },

            updateCardMask(mask) {
                if (mask.length !== 0) {
                    let largest = Math.max.apply(Math, mask[0].lengths);
                    switch (largest) {
                        case 19:
                            this.cardMask = '#### #### #### #######';
                            break;
                        case 18:
                            this.cardMask = '#### #### #### ######';
                            break;
                        default:
                            this.cardMask = '#### #### #### ####';
                            break;
                    }
                } else {
                    this.cardMask = '#### #### #### ####';
                }
            },

            async initPay () {
                this.loading = true;
                if(this.account) {
                    this.AJAX_LOADING({
                        waitingTitle: 'Оплата...'
                    });
                    const process = new CardPaymentProcess(this, null, this.account);
                    await process.pay();
                    this.AJAX_LOADING(false);
                    this.loading = false;
                    return;
                }

                if(this.$v.card.$invalid) {
                    console.log(this.$v.card);
                    this.$toastr.error('Данные карты введены не корректно', 'Ошибка');
                    this.loading = false;
                    return;
                }

                const card = {};
                const [month, year] = this.card.date.split('/');
                card.month = month;
                card.year = '20' + year;
                card.holder = this.card.holder;
                card.number = this.card.number.replace(/[^\d]/g, '');
                card.cvc = this.card.cvv;

                this.AJAX_LOADING({
                    waitingTitle: 'Оплата...'
                });
                const process = new CardPaymentProcess(this, card);
                await process.pay();
                this.AJAX_LOADING(false);
            },

            success () {
                console.log('card::success');
                this.$emit('success-pay');
            },

            error (e) {
                console.log('card::error');
                this.$emit('error-pay');
            },

            tdsConfirm (data) {
                return new Promise((resolve, reject) => {
                    this.$modal.show('tds', data);

                    this.$once('tds.ok', () => {
                        resolve();
                        this.$modal.hide('tds');
                    });
                    this.$once('tds.error', () => {
                        reject();
                        this.$modal.hide('tds');
                    });
                })
            }
        }
    };
</script>
